// stars.hxx -- data structures and routines for managing and rendering stars.
//
// Written by Curtis Olson, started August 1997.
//
// Copyright (C) 1997  Curtis L. Olson  - curt@me.umn.edu
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: stars.hxx,v 1.1.1.1 1999/06/17 18:07:37 curt Exp $


#ifndef _STARS_HXX
#define _STARS_HXX


#ifndef __cplusplus                                                          
# error This library requires C++
#endif                                   

#include <Time/fg_time.hxx>

#define FG_STAR_LEVELS 8         // how many star transitions

// Initialize the Star Management Subsystem
int fgStarsInit( void );

// Draw the Stars
void fgStarsRender( void );

// [no longer used?] extern FGTime cur_time_params;


#endif // _STARS_HXX


