// iochannel.hxx -- High level IO channel class
//
// Written by Curtis Olson, started November 1999.
//
// Copyright (C) 1999  Curtis L. Olson - curt@flightgear.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: iochannel.hxx,v 1.4 2000/02/15 02:30:06 curt Exp $


#ifndef _IOCHANNEL_HXX
#define _IOCHANNEL_HXX


#include <simgear/compiler.h>

#include "protocol.hxx"

#include STL_STRING
#include <vector>

FG_USING_STD(vector);
FG_USING_STD(string);


// forward declaration
class FGProtocol;


class FGIOChannel {

public:

    FGIOChannel();
    virtual ~FGIOChannel();

    virtual bool open( FGProtocol::fgProtocolDir dir );
    virtual int read( char *buf, int length );
    virtual int readline( char *buf, int length );
    virtual int write( char *buf, int length );
    virtual int writestring( char *str );
    virtual bool close();
};


#endif // _IOCHANNEL_HXX


